/*
* Railroad2
* Private Grader
*/

#include <cstdio>
#include <cstdlib>
#include <vector>

extern int travel(std::vector<int> U, std::vector<int> V, std::vector<int> W);

void my_assert(bool x) {
	if (!x) {
		puts("Wrong input");
		exit(0);
	}
}

int main() {
	int N;
	my_assert(scanf("%d", &N) == 1);

	int sum = 0; //secret string

	std::vector<int> U(N - 1), V(N - 1), W(N - 1);
	for (int i = 0; i < N - 1; i++) {
		my_assert(scanf("%d%d%d", &U[i], &V[i], &W[i]) == 3);
		sum ^= U[i] + V[i] + W[i];
	}
	printf("%d\n", sum);

	int answer = travel(U, V, W);
	printf("%d\n", answer);

	return 0;
}
